/***************************************************************************
 *   Copyright (C) 2005 by TAM(Teppei Tamra)                               *
 *   tam-t@par.odn.ne.jp                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef WORDSPREDICTION_H
#define WORDSPREDICTION_H

#define Uses_SCIM_CONFIG_BASE

#include <predictor.h>
#include <scim.h>
#include <scim_iconv.h>
#include <scim_attribute.h>
#include <wordsdic.h>

/**
	@author TAM (Teppei Tamra) <tam-t@par.odn.ne.jp>
*/
namespace Honoka {
class WordsPrediction : public Predictor {
public:
    WordsPrediction(ConfigPointer cfg);

    ~WordsPrediction();
    virtual ResultList getPredictionList(const WideString &str);
    virtual void disconnect();
    virtual bool connect();
    virtual bool isConnected();
    virtual String getPropertyName();
    virtual String getName();
    virtual void update(const WideString str,const WideString yomi);
    virtual int getPos();

protected:
    WordsDic *dic;
    int pos;
    bool addSpace;
    int limit;
};
}
#endif
